Trigger.prototype.IntroductionMessage = function(data)
{
	if (this.state != "start")
		return;

// TODO: We need a helper function for messages to all players!
	TriggerHelper.PushGUINotification(1, "Collect the treasures before your enemy does! May the better win!");
	TriggerHelper.PushGUINotification(2, "Collect the treasures before your enemy does! May the better win!");
};

Trigger.prototype.TreasureCollected = function(data)
{
	var count = ++this.treasureCount.players[data.player];
	var goalCount = this.treasureCount.maximum / 2 + 1
	var otherPlayer = (data.player == 1 ? 2 : 1);
	
	// Check if having more treasures than the enemy is still possible
	if ( (count == this.treasureCount.maximum / 2) && 
		(this.treasureCount.players[otherPlayer] == this.treasureCount.maximum / 2) )
	{
		TriggerHelper.PushGUINotification(1, "No winner yet, prepare for battle!");
		TriggerHelper.PushGUINotification(2, "No winner yet, prepare for battle!");
		
		// keep notifying the player that the victory condition has changed.
		var timerData = {"enabled": true, "delay": 10000, "interval": 12000}
		this.RegisterTrigger("OnInterval", "BattleMessage", timerData);
	}
	else if (count >= goalCount) // Check for victory
	{
		TriggerHelper.PushGUINotification(otherPlayer, "Your enemys treasury is filled to the brim, you loose!");
		TriggerHelper.PushGUINotification(data.player, "Your treasury is filled to the brim, you are victorious!");
		this.DoAfterDelay(5000, "Victory", data.player);
	}
	else
	{
		// Notify if the other player if a player is close to victory (3 more treasures to collect)
		if (count + 3 == goalCount)
		{
			TriggerHelper.PushGUINotification(otherPlayer, "Hurry up! Your enemy is close to victory!");
		}
		
		if (count + 3 >= goalCount)
		{
			var remainingTreasures = ( goalCount - count);
			TriggerHelper.PushGUINotification(data.player, "Only " + remainingTreasures + " more treasure(s) to collect for victory!");
		}
		else
		{
			TriggerHelper.PushGUINotification(data.player, "You have collected a treasure!");
		}
	}
};

Trigger.prototype.BattleMessage = function()
{
	TriggerHelper.PushGUINotification(1, "Defeat your enemy to win!");
	TriggerHelper.PushGUINotification(2, "Defeat your enemy to win!");
}

Trigger.prototype.Victory = function(playerID)
{
	TriggerHelper.SetPlayerWon(playerID);
}

///////////////////////////////////////////////////////////////////////////////
//                            Startup Actions                                //
///////////////////////////////////////////////////////////////////////////////

// This function is run in the start of the game. We should initialize everything here.
Trigger.prototype.InitGame = function(data)
{
	// Our trigger variables should be defined here or they will be lost
	// after a save.
	// This map will use some states, to know in which part of the tutorial it is
	// possible states:
	//[ start, movingTutorial1, movingTutorial2, gatheringFruit, gatheringWood, gatheringStone, gatheringMetal, goToTriggerPoint,gatheringTreasure, complete]
	
// TODO: It would be nice to get the total number of treasure on the map automatically somehow
	this.treasureCount = { "players": { "1":0,"2":0 }, "maximum": 36 };
	this.state = "start";

	// Start the first tutorial after 2 seconds.
	this.DoAfterDelay(2000, "IntroductionMessage", {});

	///////////////////////////////////////////////////////////////////////////
	//                           Register Triggers                           //
	///////////////////////////////////////////////////////////////////////////

	// For a trigger to work, actions should be bound to an event.
	this.RegisterTrigger("OnTreasureCollected", "TreasureCollected", { "enabled": true });
};
