// Global variable. Nothing except g_TriggerData and constants should be
// defined here or they will be lost after a save/load.
var g_TriggerData = {}

///////////////////////////////////////////////////////////////////////////////
//                           Function defenitions                            //
///////////////////////////////////////////////////////////////////////////////

// These actions control the tutorials in which the player has no interaction with.
g_TriggerData.WelcomeMessage = function(data)
{
	var cmpTrigger = GetTriggerComponent()
	PushGUINotificationInTopCenter(1, "Welcome to the basic tutorial of the 0 A.D.!");
	cmpTrigger.DoAfterDelay(3000, "IntroductionMessage", {});
}

g_TriggerData.IntroductionMessage = function(data)
{
	var cmpTrigger = GetTriggerComponent()
	PushGUINotificationInTopCenter(1, "In this tutorial you will learn the basics of the gameplay of 0 A.D.");
	cmpTrigger.DoAfterDelay(6000, "CameraMovementTutorial1", {});
}

g_TriggerData.CameraMovementTutorial1 = function(data)
{
	var cmpTrigger = GetTriggerComponent()
	PushGUINotificationInTopCenter(1, "First, we try the camera movements. To move your camera, move the mouse pointer to the edge of the screen.");
	cmpTrigger.DoAfterDelay(8000, "CameraMovementTutorial2", {});
}

g_TriggerData.CameraMovementTutorial2 = function(data)
{
	var cmpTrigger = GetTriggerComponent()
	PushGUINotificationInTopCenter(1, "You can also move the camera using W,A,S,D or arrow keys on the keyboard, or by holding the middle mouse button and moving it.");
	cmpTrigger.DoAfterDelay(15000, "CameraMovementTutorial3", {});
}

g_TriggerData.CameraMovementTutorial3 = function(data)
{
	var cmpTrigger = GetTriggerComponent()
	PushGUINotificationInTopCenter(1, "To rotate the camera, hold Ctrl and one of the arrow keys.");
	cmpTrigger.DoAfterDelay(7000, "CameraMovementTutorial4", {});
}

g_TriggerData.CameraMovementTutorial4 = function(data)
{
	var cmpTrigger = GetTriggerComponent()
	PushGUINotificationInTopCenter(1, "To zoom, use the mouse scroll or + and - keys on the keyboard.");
	cmpTrigger.DoAfterDelay(7000, "IntroductionToUnits", {});
}

g_TriggerData.IntroductionToUnits = function(data)
{
	var cmpTrigger = GetTriggerComponent()
	PushGUINotificationInTopCenter(1, "Now it is time to work with units. Move the mouse pointer on one of the units present in the screen, and left-click to select it. Then, right-click on an open part of the terrain.");
	cmpTrigger.EnableIntervalTrigger("MovingUnitsTutorial");
	cmpTrigger.EnableTrigger("OnUnitIssuedOrder", "HandleOrders");
}

g_TriggerData.IntroductionToResources = function(data)
{
	var cmpTrigger = GetTriggerComponent()
	PushGUINotificationInTopCenter(1, "Resource gathering play a central role in 0 A.D.. There are four resources found in the game. Food, Wood, Stone and metal. You can find your current stockpile in the upper left section of the screen.");
	cmpTrigger.DoAfterDelay(15000, "MoreDescriptionAboutResources", {});
}

g_TriggerData.MoreDescriptionAboutResources = function(data)
{
	var cmpTrigger = GetTriggerComponent()
	PushGUINotificationInTopCenter(1, "Resources are required to train units, build structures and research technologies.");
	cmpTrigger.EnableIntervalTrigger("TutorialOnGatheringFood");
}

// These actions remind the players of what they should do.
g_TriggerData.MovingUnitsTutorial = function(data)
{
	PushGUINotificationInTopCenter(1, "Select a unit by left clicking on it, and then, right-click on an open part of the terrain.");
}

g_TriggerData.MovingAGroupOfUnitsTutorial = function(data)
{
	PushGUINotificationInTopCenter(1, "Hold the left button of the mouse and drag it to select a group of units. Then, order them to move.");
}

g_TriggerData.TutorialOnGatheringFood = function(data)
{
	PushGUINotificationInTopCenter(1, "Food is gathered from farms, fruit trees and bushes, animals, fishes and farms. Select some of your units and right-click on the berry bushes in the east to gather food.");
}

g_TriggerData.TutorialOnGatheringWood = function(data)
{
	PushGUINotificationInTopCenter(1, "Wood is gathered from trees. Select some of your units and right-click on a tree to gather wood.");
}

g_TriggerData.TutorialOnGatheringStone = function(data)
{
	PushGUINotificationInTopCenter(1, "Stone is gathered from stone quarries. Select some of your units and right-click on the quarry in the south of your town to gather stone.");
}

g_TriggerData.TutorialOnGatheringMetal = function(data)
{
	PushGUINotificationInTopCenter(1, "Metal is gathered from metal ores. Select some of your units and right-click on the rock in the north-east of your town to gather metal.");
}

g_TriggerData.TutorialOnExploration = function(data)
{
	PushGUINotificationInTopCenter(1, "Notice that you can only see the immidiate surroundings of you town. To see further, select your rider and order him to move along the south-eastern road into the black area.");
}

g_TriggerData.TutorialOnGatheringTreasure = function(data)
{
	PushGUINotificationInTopCenter(1, "Order your rider to gather the treasures. To do so, select your rider and right-click on one of the treasures near the road.");
}

// Thse actions set the next stage of the tutorial after the player has successfully done the previous ones

g_TriggerData.HandleOrders = function(data)
{
	if (data.order == "Order.Walk")
		this.PlayerMovedAUnit(data);
	else if (data.order == "Order.Gather")
	{
		var type = GetEntityResourceType(data.target);
		if (type === undefined)
			return;
		else if (type.specific == "fruit")
			this.UnitOrderedToGatherFruit(data);
		else if (type.specific == "tree")
			this.UnitOrderedToGatherTree(data);
		else if (type.specific == "rock")
			this.UnitOrderedToGatherStoneQuarry(data);
		else if (type.specific == "ore")
			this.UnitOrderedToGatherMetalMine(data);
		else if (type.generic == "treasure")
			this.UnitOrderedToGatherTreasure(data);
	}
}

g_TriggerData.HandleMultipleEntityOrders = function(data)
{
	var cmpTrigger = GetTriggerComponent()
	if (data.order == "Order.Walk")
	{
		if (cmpTrigger.GetVariable("movingTutorial1Completed") && (!cmpTrigger.GetVariable("movingTutorial2Completed")))
		{
			cmpTrigger.SetVariable("movingTutorial2Completed", true);
			cmpTrigger.DisableIntervalTrigger("MovingAGroupOfUnitsTutorial");
			PushGUINotificationInTopCenter(1, "Very Good.");
			cmpTrigger.DoAfterDelay(6000, "IntroductionToResources", {});
		}
	}
}

// This one is called when the player moves a unit.
g_TriggerData.PlayerMovedAUnit = function(data)
{
	var cmpTrigger = GetTriggerComponent()
	if (!cmpTrigger.GetVariable("movingTutorial1Completed"))
	{
		cmpTrigger.SetVariable("movingTutorial1Completed", true);
		cmpTrigger.DisableIntervalTrigger("MovingUnitsTutorial");
		PushGUINotificationInTopCenter(1, "Good. You can also select a group of units by holding the left mouse button and dragging it. Select a group of units and order them to move.");
		cmpTrigger.EnableIntervalTrigger("MovingAGroupOfUnitsTutorial");
		cmpTrigger.EnableTrigger("OnUnitsIssuedOrder", "HandleMultipleEntityOrders");
	}
}

// This one is called when the player orders a unit to gather from fruit bushes
g_TriggerData.UnitOrderedToGatherFruit = function(data)
{
	var cmpTrigger = GetTriggerComponent()
	if (!cmpTrigger.GetVariable("gatheringFruitCompleted"))
	{
		PushGUINotificationInTopCenter(1, "Excelent. Now your units will move and gather food from those bushes.");
		cmpTrigger.DisableIntervalTrigger("TutorialOnGatheringFood");
		
		cmpTrigger.EnableIntervalTrigger("TutorialOnGatheringWood");
		
		cmpTrigger.SetVariable("gatheringFruitCompleted", true);
	}
}

// This one is called when the player orders a unit to gather from trees
g_TriggerData.UnitOrderedToGatherTree = function(data)
{
	var cmpTrigger = GetTriggerComponent()
	if (!cmpTrigger.GetVariable("gatheringTreeCompleted"))
	{
		PushGUINotificationInTopCenter(1, "Perfect. Now your units will move and gather wood from the trees.");
		cmpTrigger.DisableIntervalTrigger("TutorialOnGatheringWood");
		
		cmpTrigger.EnableIntervalTrigger("TutorialOnGatheringStone");
		
		cmpTrigger.SetVariable("gatheringTreeCompleted", true);
	}
}

// This one is called when the player orders a unit to gather from stone quarries
g_TriggerData.UnitOrderedToGatherStoneQuarry = function(data)
{
	var cmpTrigger = GetTriggerComponent()
	if (!cmpTrigger.GetVariable("gatheringStoneCompleted"))
	{
		PushGUINotificationInTopCenter(1, "Good. Now your units will move and gather stone from the quarry.");
		cmpTrigger.DisableIntervalTrigger("TutorialOnGatheringStone");

		cmpTrigger.EnableIntervalTrigger("TutorialOnGatheringMetal");
		
		cmpTrigger.SetVariable("gatheringStoneCompleted", true);
	}
}

// This one is called when the player orders a unit to gather from metal mines
g_TriggerData.UnitOrderedToGatherMetalMine = function(data)
{
	var cmpTrigger = GetTriggerComponent()
	if (!cmpTrigger.GetVariable("gatheringMetalCompleted"))
	{
		PushGUINotificationInTopCenter(1, "Very Good. Now your units will move and gather metal from the ore.");
		cmpTrigger.DisableIntervalTrigger("TutorialOnGatheringMetal");
		
		// Spawn a cavalry unit for the player in his/her civic center.
		var playerEntities = GetEntitiesByPlayer(1); // Get all of the player's entities
		for each (entity in playerEntities)
		{
			if (EntityHasClass(entity, "CivilCentre"))
			{
				BuildingSpawnUnits(entity, "skirmish/units/default_cavalry", 1);
				break;
			}
		}
		
		cmpTrigger.EnableIntervalTrigger("TutorialOnExploration");
		cmpTrigger.EnableRangeTrigger("StartTreasureTutorial");
		
		cmpTrigger.SetVariable("gatheringMetalCompleted", true);
	}
}

// This one is called when a unit gets near the market in the south-east
g_TriggerData.StartTreasureTutorial = function(data)
{
	var cmpTrigger = GetTriggerComponent()
	PushGUINotificationInTopCenter(1, "You have found some treasures. Treasures give large ammount of their representing resources instantly. Order your rider to gather the treasures.");
	cmpTrigger.DisableIntervalTrigger("TutorialOnExploration");
	cmpTrigger.DisableRangeTrigger("StartTreasureTutorial");
	
	cmpTrigger.EnableIntervalTrigger("TutorialOnGatheringTreasure");
}

// This one is called when the player orders a unit to gather from treasures
g_TriggerData.UnitOrderedToGatherTreasure = function(data)
{
	var cmpTrigger = GetTriggerComponent()
	if (!cmpTrigger.GetVariable("gatheringTreasureCompleted"))
	{
		PushGUINotificationInTopCenter(1, "Outstanding. This tutorial is now done.");
		cmpTrigger.DisableIntervalTrigger("TutorialOnGatheringTreasure");
		
		cmpTrigger.SetVariable("gatheringTreasureCompleted", true);
		
		cmpTrigger.DoAfterDelay(4000, "Victory", {});
	}
}

g_TriggerData.Victory = function(data)
{
	SetPlayerWon(1);
}

///////////////////////////////////////////////////////////////////////////////
//                            Startup Actions                                //
///////////////////////////////////////////////////////////////////////////////

// This function is run in the start of the game. We should initialize everything here.
g_TriggerData.InitTriggers = function(data)
{
	var cmpTrigger = GetTriggerComponent()
	
	// Our trigger variables should be defined here or they will be lost
	// after a save.
	cmpTrigger.SetVariable("movingTutorial1Completed" ,false);
	cmpTrigger.SetVariable("movingTutorial2Completed" ,false);
	cmpTrigger.SetVariable("gatheringFruitCompleted" ,false);
	cmpTrigger.SetVariable("gatheringTreeCompleted" ,false);
	cmpTrigger.SetVariable("gatheringStoneCompleted" ,false);
	cmpTrigger.SetVariable("gatheringMetalCompleted" ,false);
	cmpTrigger.SetVariable("gatheringTreasureCompleted" ,false);
	
	// Start the first tutorial after 2 seconds.
	cmpTrigger.DoAfterDelay(2000, "WelcomeMessage", {});

	///////////////////////////////////////////////////////////////////////////
	//                           Register Triggers                           //
	///////////////////////////////////////////////////////////////////////////

	// For a trigger to work, actions should be bound to an event.
	// Interval triggers, when active, are run infinitely each interval.
	cmpTrigger.RegisterOnIntervalTrigger("MovingUnitsTutorial", 10000, 12000, false); 		  // The first paramete is the function
																							  // call in each interval.
	cmpTrigger.RegisterOnIntervalTrigger("MovingAGroupOfUnitsTutorial", 10000, 10000, false); // The first number is the number of
																							  // miliseconds before the start of the
																							  // interval. The second is the number
																							  // of miliseconds between each interval
	cmpTrigger.RegisterOnIntervalTrigger("TutorialOnGatheringFood", 5000, 10000, false);      // "false" means that it is disabled by default
	cmpTrigger.RegisterOnIntervalTrigger("TutorialOnGatheringWood", 5000, 10000, false);
	cmpTrigger.RegisterOnIntervalTrigger("TutorialOnGatheringStone", 5000, 10000, false);
	cmpTrigger.RegisterOnIntervalTrigger("TutorialOnGatheringMetal", 5000, 10000, false);
	cmpTrigger.RegisterOnIntervalTrigger("TutorialOnExploration", 5000, 10000, false);
	
	// Range triggers are run when a unit enters or leaves the circle around an entity
	cmpTrigger.RegisterOnUnitRangeFromEntityTrigger(
		"entered", // Means that the event is called whn a unit enters the range. Can also be "left".
		226, // ID of the entity that the range is calculated around. In this map, it is the celtic market along the road.
			 // You can find the IDs of entities in scenario and skirmish maps in their ".xml" files.
		40,  // The "range" parameter. How far the circle extends
		"StartTreasureTutorial", // The action to do when a unit leaves or enters the range
		[1], // The list of the players that can own the "entering" units. Use "undefined" to set it for all of the players
		0, //To get better performance, it is adviced to use IID_DamageReceiver instead of 0 although it would limit the entites that signal the event to the ones that can recieve damage.
		false // This trigger is disabled by default.
	);
	
	cmpTrigger.RegisterOnIntervalTrigger("TutorialOnGatheringTreasure", 5000, 10000, false);
	
	// Normal triggers. The first parameter is the "event". The second one is the action, and the third one is the default enability
	cmpTrigger.RegisterTrigger("OnUnitIssuedOrder", "HandleOrders", false);
	cmpTrigger.RegisterTrigger("OnUnitsIssuedOrder", "HandleMultipleEntityOrders", false);
}

///////////////////////////////////////////////////////////////////////////////
//                              Setting Actions Up                           //
///////////////////////////////////////////////////////////////////////////////

// The set of global trigger actions. The name must always be "g_TriggerData"
// Make the trigger actions global so that we can use it in the trigger component.
Engine.RegisterGlobal("g_TriggerData", g_TriggerData);